Description

Hi

Attachments of an issue that are related to custom fields of type attachment, get not deleted after issue deletion.

Associated revisions

Revision 23161 - 2024-10-26 04:14 - Go MAEDA

Fix missing deletion of custom field attachments upon issue deletion (#38966).

Patch by Takenori TAKAKI (user:takenory).

History

#1 - 2023-08-30 09:59 - Go MAEDA

- Status changed from New to Confirmed

#2 - 2023-09-06 23:32 - salman mp

- File remove_attachment_cf_values.patch added

As a suggestion, this patch removed attachment custom values before customizable destroy.

#3 - 2023-09-07 08:11 - Takenori TAKAKI

- File fix-38966-remove_attachment_after_custom_value_deleted.patch added

I would like to propose a patch and test code to delete the Attachment after the custom value has been removed.

#4 - 2023-09-08 16:57 - salman mp

Takenori TAKAKI wrote in #note-3:

I would like to propose a patch and test code to delete the Attachment after the custom value has been removed.

 Thanks. It's better than mine.

#5 - 2023-09-09 13:38 - Takenori TAKAKI

salman mp wrote in #note-4:

Takenori TAKAKI wrote in #note-3:

I would like to propose a patch and test code to delete the Attachment after the custom value has been removed.

 Thanks. It's better than mine.

 Thanks salman mp ! Looks like we both had the same idea around the same time. Really appreciate your feedback!

#6 - 2023-12-30 09:52 - Go MAEDA

- Target version set to Candidate for next major release
Thank you for posting the fix. Should we add a migration to delete orphaned objects?

#7 - 2023-12-30 18:24 - salman mp

Go MAEDA wrote in #note-6:

Thank you for posting the fix. Should we add a migration to delete orphaned objects?

 Good idea. Because, if that orphaned objects not destroyed here, no one will destroy them in the future  even by attachment:prune rake task.

It this sufficient?

class RemoveOrphanedCustomValueAttachments < ActiveRecord::Migration[6.1]

  def up

    Attachment.where(container_type: "CustomValue").each do |a|

      a.destroy! if a.container.nil?

    end

  end

  def down

    # no-op

  end

end

#8 - 2024-05-23 11:15 - Go MAEDA

- File 20240523085253_remove_orphaned_custom_value_attachments.rb added

salman mp, thank you for posting the migration file.

I think the attached migration is more efficient than iterating over all attachments returned by Attachment.where(container_type: "CustomValue").

#9 - 2024-05-23 11:16 - Go MAEDA

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#10 - 2024-10-22 12:04 - Go MAEDA

- File 38966-v3.patch added

I have updated the patch:

Added a migration to delete orphaned attachments

Changed callback method names to be more descriptive

Removed a loop from destroy_custom_value_attachments for improved efficiency

#11 - 2024-10-22 16:12 - Takenori TAKAKI

Go MAEDA

I have confirmed the patch.

The added migration, proper naming and loop removal would be good!

#12 - 2024-10-26 04:16 - Go MAEDA

- Subject changed from Attachments custom fields not removed when issue deleted to Attachment custom fields not removed when issue is deleted

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23161. Thank you for your contribution.

Files

remove_attachment_cf_values.patch 1.24 KB 2023-09-06 salman mp

fix-38966-remove_attachment_after_custom_value_deleted.patch 2.81 KB 2023-09-07 Takenori TAKAKI

20240523085253_remove_orphaned_custom_value_attachments.rb317 Bytes 2024-05-23 Go MAEDA
